#include "bits/stdc++.h"
#include "testlib.h"
#include "limits.h"
using namespace std;

#define all(x) x.begin(), x.end()
 
int get_diff(vector<int> a) {
    set<int> st;
    for (auto it : a) {
        st.insert(it);
    }
    return (int) st.size();
}

int main(int argc, char** argv) {
    registerValidation(argc, argv);
    
    int group = 0;
    if (validator.group() == "") {
        group = 10; // это полная группа, все тесты должны укладываться в эти ограничения
    } else {
        group = stoi(validator.group());
    }
    
    const auto limits = LIMITS[group];
    
    int t = inf.readInt(limits.min_t, limits.max_t, "~t~");
    inf.readEoln();
    int sum_n = 0, sum_m = 0;
    for (int test = 1; test <= t; ++test) {
        setTestCase(test);
        int n = inf.readInt(limits.min_n, limits.max_n, "~n~");
        inf.readSpace();
        int m = inf.readInt(limits.min_m, limits.max_m, "~m~");
        inf.readEoln();
        sum_n += n;
        sum_m += m;
        ensuref(sum_n <= limits.sum_n, "The sum of n exceeds N");
        ensuref(sum_m <= limits.sum_m, "The sum of m exceeds M");
        vector<int> x = inf.readInts(m, limits.min_x, limits.max_x, "~x_i~");
        inf.readEoln();
        if (limits.one_diff) {
            ensuref(get_diff(x) == 1, "The restriction of group 1 is not fulfilled");
        } else if (limits.two_diff) {
            ensuref(get_diff(x) <= 2, "The restriction of group 8 is not fulfilled");
        }
    }
    inf.readEof();
}
