#include "bits/stdc++.h"

using namespace std;

#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define int long long

const int INF = 1e18;

struct segtree {
    struct Node {
        int ass = 0;
        int mini = INF;
        int maxi = -INF;
        
        void merge(Node n1, Node n2) {
            mini = min(n1.mini, n2.mini);
            maxi = max(n1.maxi, n2.maxi);
        }
    };
    
    vector<Node> tree;
    int size = 1;
    
    void init(int n, vector<int> &b) {
        while (size <= n + 1) {
            size <<= 1;
        }
        tree.resize(2 * size);
        build(0, 0, size, b);
    }
    
    void build(int x, int lx, int rx, vector<int> &b) {
        if (rx - lx == 1) {
            if (lx < b.size()) {
                tree[x] = {0, b[lx], b[lx]};
            }
            return;
        }
        int m = (lx + rx) / 2;
        build(2 * x + 1, lx, m, b);
        build(2 * x + 2, m, rx, b);
        tree[x].merge(tree[2 * x + 1], tree[2 * x + 2]);
    }
    
    void push(int x, int lx, int rx) {
        tree[x].mini += tree[x].ass;
        tree[x].maxi += tree[x].ass;
        if (rx - lx == 1) {
            tree[x].ass = 0;
            return;
        }
        tree[2 * x + 1].ass += tree[x].ass;
        tree[2 * x + 2].ass += tree[x].ass;
        tree[x].ass = 0;
    }
    
    void update(int l, int r, int val, int x, int lx, int rx) {
        push(x, lx, rx);
        if (l <= lx && rx <= r) {
            tree[x].ass += val;
            push(x, lx, rx);
            return;
        }
        if (rx <= l || r <= lx) {
            return;
        }
        int m = (lx + rx) / 2;
        update(l, r, val, 2 * x + 1, lx, m);
        update(l, r, val, 2 * x + 2, m, rx);
        tree[x].merge(tree[2 * x + 1], tree[2 * x + 2]);
    }
    
    void update(int l, int r, int val) {
        update(l, r + 1, val, 0, 0, size);
    }
    
    int get_max(int l, int r, int x, int lx, int rx) {
        push(x, lx, rx);
        if (l <= lx && rx <= r) {
            return tree[x].maxi;
        }
        if (r <= lx || rx <= l) {
            return -INF;
        }
        int m = (lx + rx) / 2;
        int val = max(get_max(l, r, 2 * x + 1, lx, m), get_max(l, r, 2 * x + 2, m, rx));
        return val;
    }
    
    int get_max(int l, int r) {
        return get_max(l, r + 1, 0, 0, size);
    }
    
    int get_min(int l, int r, int x, int lx, int rx) {
        push(x, lx, rx);
        if (l <= lx && rx <= r) {
            return tree[x].mini;
        }
        if (r <= lx || rx <= l) {
            return INF;
        }
        int m = (lx + rx) / 2;
        int val = min(get_min(l, r, 2 * x + 1, lx, m), get_min(l, r, 2 * x + 2, m, rx));
        return val;
    }
    
    int get_min(int l, int r) {
        return get_min(l, r + 1, 0, 0, size);
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pair<int, int>> x(m);
    for (int i = 0; i < m; ++i) {
        cin >> x[i].fi;
        x[i].fi = abs(x[i].fi);
        x[i].se = i;
    }
    sort(all(x));
    reverse(all(x));
    vector<int> b(m, -1);
    vector<int> l(m);
    for (int i = 0; i < m; i++) {
        l[i] = - (m - i);
    }
    segtree tree;
    tree.init(m, l);
    for (int i = 0; i < m; i++) {
        int mins = min(0ll, tree.get_min(x[i].se + 1, m - 1));
        mins = - mins;
        mins += mins % 2;
        int maxs = tree.get_max(0, x[i].se);
        if (maxs + 2 + mins <= n) {
            b[x[i].se] = 1;
            tree.update(0, x[i].se, 2);
        }
    }
    
    int sum = 0;
    for (int i = 0; i < m; i++) {
        sum += x[i].fi * b[x[i].se];
    }
    cout << sum << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
