#include "bits/stdc++.h"
using namespace std;
 
#define int long long
#define fi first
#define se second
 
const int INF = 1000'000'000'000'000'000;
 
struct segtree {
    vector<int> tree, ass;
    int size = 1;
 
    void init(int n) {
        while (size <= n)
            size <<= 1;
        tree.resize(2 * size, INF);
        ass.resize(2 * size);
    }
 
    void push(int x, int lx, int rx) {
        tree[x] += ass[x];
        if (rx - lx == 1) {
            ass[x] = 0;
            return;
        }
        ass[2 * x + 1] += ass[x];
        ass[2 * x + 2] += ass[x];
        ass[x] = 0;
    }
 
    void update(int l, int r, int val, int x, int lx, int rx) {
        push(x, lx, rx);
        if (l <= lx && rx <= r) {
            ass[x] += val;
            push(x, lx, rx);
            return;
        }
        if (rx <= l || r <= lx)
            return;
        int m = (lx + rx) / 2;
        update(l, r, val, 2 * x + 1, lx, m);
        update(l, r, val, 2 * x + 2, m, rx);
        tree[x] = min(tree[2 * x + 1], tree[2 * x + 2]);
    }
 
    void update(int l, int r, int val) {
        update(l, r + 1, val, 0, 0, size);
    }
 
    void update_pt(int i, int val, int x, int lx, int rx) {
        push(x, lx, rx);
        if (rx - lx == 1) {
            tree[x] = val;
            return;
        }
        int m = (lx + rx) / 2;
        if (i < m)
            update_pt(i, val, 2 * x + 1, lx, m);
        else
            update_pt(i, val, 2 * x + 2, m, rx);
        push(2 * x + 1, lx, m);
        push(2 * x + 2, m, rx);
        tree[x] = min(tree[2 * x + 1], tree[2 * x + 2]);
    }
 
    void update_pt(int i, int val) {
        update_pt(i, val, 0, 0, size);
    }
 
    int get(int x, int lx, int rx) {
        push(x, lx, rx);
        if (rx - lx == 1) {
            return lx;
        }
        int m = (lx + rx) / 2;
        push(2 * x + 1, lx, m);
        push(2 * x + 2, m, rx);
        if (tree[2 * x + 1] <= 1)
            return get(2 * x + 1, lx, m);
        else
            return get(2 * x + 2, m, rx);
    }
 
    int get() {
        return get(0, 0, size);
    }
};
 
void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> x(m);
    for (int i = 0; i < m; i++) {
        cin >> x[i];
    }
    vector<bool> ans(m);
    deque<int> act;
    multiset<pair<int, int>> ms;
    int b = 0;
    segtree tree;
    tree.init(m);
    for (int i = m - 1; i >= 0; i--) {
        if (b < n) {
            act.push_front(i);
            b++;
            ans[i] = true;
            ms.insert({x[i], i});
            tree.update_pt(i, b);
            continue;
        } else {
            b--;
        }
        int k = tree.get() - 1;
        while (!act.empty() && act.back() > k) {
            ms.erase({x[act.back()], act.back()});
            act.pop_back();
        }
        tree.update_pt(i, b);
        int pos = -1;
        if (!ms.empty()) {
            pos = ms.begin()->se;
        }
        if (pos != -1 && x[pos] < x[i]) {
            ans[pos] = false;
            ms.erase(ms.begin());
            ans[i] = true;
            tree.update(i + 1, pos, -2);
            ms.insert({x[i], i});
            act.push_front(i);
        }
    }
    int res = 0;
    for (int j = m - 1; j >= 0; j--) {
        if (ans[j]) {
            res += x[j];
        } else {
            res -= x[j];
        }
    }
    cout << res << endl;
}
 
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
