#include "bits/stdc++.h"
using namespace std;
 
#define int long long
#define fi first
#define se second
 
const int INF = 1000'000'000'000'000'000;
 
struct Segtree {
    struct Node {
        int max_b = 0;
        int min_b = INF;
        pair<int, int> min_val = {INF, INF};
        pair<int, int> max_val = {- INF, INF};
        int ass = 0;
        char type = '.';
    };
    
    vector<Node> tree;
    int size = 1;
    int bound;
    
    void init(int n, int m) {
        while (size < m) {
            size <<= 1;
        }
        tree.resize(2 * size, {});
        bound = n - 2;
    }
    
    void push(int x, int lx, int rx) {
        if (rx - lx == 1) {
            return;
        }
        tree[2 * x + 1].min_b += tree[x].ass;
        tree[2 * x + 2].min_b += tree[x].ass;
        tree[2 * x + 1].max_b += tree[x].ass;
        tree[2 * x + 2].max_b += tree[x].ass;
        tree[2 * x + 1].ass += tree[x].ass;
        tree[2 * x + 2].ass += tree[x].ass;
        tree[x].ass = 0;
    }
    
    void merge_nodes(Node &res, Node &n1, Node &n2) {
        res.min_val = min(n1.min_val, n2.min_val);
        res.max_val = max(n1.max_val, n2.max_val);
        res.min_b = min(n1.min_b, n2.min_b);
        res.max_b = max(n1.max_b, n2.max_b);
    }
    
    void update_point(int i, int val, int balance, char type, int x, int lx, int rx) {
        push(x, lx, rx);
        if (rx - lx == 1) {
            tree[x].type = type;
            tree[x].min_b = balance;
            tree[x].max_b = balance;
            if (type == '+') {
                tree[x].min_val = {val, lx};
            } else {
                tree[x].max_val = {val, lx};
            }
            return;
        }
        int m = (lx + rx) / 2;
        if (i < m) {
            update_point(i, val, balance, type, 2 * x + 1, lx, m);
        } else {
            update_point(i, val, balance, type, 2 * x + 2, m, rx);
        }
        merge_nodes(tree[x], tree[2 * x + 1], tree[2 * x + 2]);
    }
    
    void update_point(int i, int val, int balance, char type) {
        update_point(i, val, balance, type, 0, 0, size);
    }
    
    void swap_sign(int i, int x, int lx, int rx) {
        push(x, lx, rx);
        if (rx - lx == 1) {
            swap(tree[x].min_val, tree[x].max_val);
            if (tree[x].type == '+') {
                tree[x].type = '-';
                tree[x].min_val = {INF, INF};
                
            } else {
                tree[x].type = '+';
                tree[x].max_val = {- INF, INF};
            }
            return;
        }
        int m = (lx + rx) / 2;
        if (i < m) {
            swap_sign(i, 2 * x + 1, lx, m);
        } else {
            swap_sign(i, 2 * x + 2, m, rx);
        }
        merge_nodes(tree[x], tree[2 * x + 1], tree[2 * x + 2]);
    }
    
    void swap_sign(int i) {
        swap_sign(i, 0, 0, size);
    }
    
    void update_seg(int l, int r, int delta, int x, int lx, int rx) {
        push(x, lx, rx);
        if (l <= lx && rx <= r) {
            tree[x].min_b += delta;
            tree[x].max_b += delta;
            tree[x].ass += delta;
            return;
        }
        if (rx <= l || r <= lx) {
            return;
        }
        int m = (lx + rx) / 2;
        update_seg(l, r, delta, 2 * x + 1, lx, m);
        update_seg(l, r, delta, 2 * x + 2, m, rx);
        merge_nodes(tree[x], tree[2 * x + 1], tree[2 * x + 2]);
    }
    
    void update_seg(int l, int r, int delta) {
        update_seg(l, r + 1, delta, 0, 0, size);
    }
    
    pair<int, int> get_min(int x, int lx, int rx) {
        push(x, lx, rx);
        if (rx - lx == 1) {
            if (tree[x].min_b > 1){
                return tree[x].min_val;
            } else {
                return {INF, INF};
            }
        }
        int m = (lx + rx) / 2;
        if (tree[2 * x + 1].min_b > 1) {
            return min(tree[2 * x + 1].min_val, get_min(2 * x + 2, m, rx));
        } else {
            return get_min(2 * x + 1, lx, m);
        }
    }
    
    int get_min() {
        return get_min(0, 0, size).se;
    }
    
    pair<int, int> get_max(int x, int lx, int rx) {
        push(x, lx, rx);
        if (rx - lx == 1) {
            if (tree[x].max_b <= bound) {
                return tree[x].max_val;
            } else {
                return {-INF, INF};
            }
        }
        int m = (lx + rx) / 2;
        push(2 * x + 1, lx, m);
        push(2 * x + 2, m, rx);
        if (tree[2 * x + 1].max_b <= bound) {
            return max(tree[2 * x + 1].max_val, get_max(2 * x + 2, m, rx));
        } else {
            return get_max(2 * x + 1, lx, m);
        }
    }
    
    int get_max() {
        return get_max(0, 0, size).se;
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> x(m);
    for (int i = 0; i < m; ++i) {
        cin >> x[i];
    }
    x.push_back(INF);
    x.push_back(-INF);
    Segtree tree;
    tree.init(n, m);
    int balance = 0;
    int sum = 0;
    for (int i = m - 1; i >= 0; --i) {
        int min_pos = tree.get_min();
        min_pos = min(min_pos, m);
        int max_pos = tree.get_max();
        max_pos = min(max_pos, m + 1);
        int new_sum1, new_sum2;
        if (balance < n) {
            new_sum1 = sum + x[i];
        } else {
            new_sum1 = sum + x[i] - 2 * x[min_pos];
        }
        if (balance > 0) {
            new_sum2 = sum - x[i];
        } else {
            new_sum2 = sum - x[i] + 2 * x[max_pos];
        }
        if (new_sum1 > new_sum2) {
            sum = new_sum1;
            if (balance == n) {
                tree.update_seg(i, min_pos, -2);
                tree.swap_sign(min_pos);
                --balance;
            } else {
                ++balance;
            }
            tree.update_point(i, x[i], balance, '+');
        } else {
            sum = new_sum2;
            if (balance == 0) {
                tree.update_seg(i, max_pos, 2);
                tree.swap_sign(max_pos);
                ++balance;
            } else {
                --balance;
            }
            tree.update_point(i, x[i], balance, '-');
        }
    }
    cout << sum << '\n';
}
 
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
